# CvOverlayHelpers.py
# 
# Oct 20, 2008
# Helper functions for Strategy Overlay mod

from CvPythonExtensions import *
import CvUtil

# Globals
gc = CyGlobalContext()
iface = CyInterface()


class CvOverlayHelper:
    """
    Helper function class for strategy overlay
    """
    NotifyCodesMap = {
        NotifyCode.NOTIFY_CHARACTER : "Character",
        NotifyCode.NOTIFY_CLICKED : "Click",
        NotifyCode.NOTIFY_CURSOR_MOVE_OFF : "Cursor Off",
        NotifyCode.NOTIFY_CURSOR_MOVE_ON : "Cursor On",
        NotifyCode.NOTIFY_DBL_CLICKED : "Double Click",
        NotifyCode.NOTIFY_FLYOUT_ITEM_SELECTED : "Flyout Select",
        NotifyCode.NOTIFY_FOCUS : "Focus",
        NotifyCode.NOTIFY_LINKEXECUTE : "Link Execute",
        NotifyCode.NOTIFY_LISTBOX_ITEM_SELECTED : "Listbox Item Selected",
        NotifyCode.NOTIFY_MOUSEMOVE : "Mouse Move",
        NotifyCode.NOTIFY_MOUSEWHEELDOWN : "Mousewheel Down",
        NotifyCode.NOTIFY_MOUSEWHEELUP : "Mousewheel Up",
        NotifyCode.NOTIFY_MOVIE_DONE : "Movie Done",
        NotifyCode.NOTIFY_NEW_HORIZONTAL_STOP : "New Horiz Stop",
        NotifyCode.NOTIFY_NEW_VERTICAL_STOP : "New Vert Stop",
        NotifyCode.NOTIFY_SCROLL_DOWN : "Scroll Down",
        NotifyCode.NOTIFY_SCROLL_UP : "Scroll Up",
        NotifyCode.NOTIFY_SLIDER_NEWSTOP : "Slider Newstop",
        NotifyCode.NOTIFY_TABLE_HEADER_SELECTED : "Table Header Selected",
        NotifyCode.NOTIFY_UNFOCUS  : "Unfocus",
    }
    
    def __init__(self):
        self.bDebug = True
        
    def GameMsg(self, text):
        iface.addImmediateMessage(text,"")
    
    def ConsoleMsg(self, text):
        CvUtil.RedirectDebug().write(text)
        
    def GameAssert(self, cond, msg):
        if (cond == False):
            iface.addImmediateMessage(msg, "")
        assert(cond,msg)
    
    def ConsoleAssert(self, cond, msg):
        if (cond == False):
            CvUtil.RedirectError().write(msg)
        assert(cond,msg)
        
    def InputPrint(self, inputClass):
        """
        Debug print out of screen input event
        
        @Param inputClass: The ScreenInput class to print
        """
        message = "Notify Code: "
        if (self.NotifyCodesMap.has_key(inputClass.getNotifyCode())):
            message += self.NotifyCodesMap.get(inputClass.getNotifyCode())
        message += "\n"
        message += "Python File: " + str(inputClass.getPythonFile()) + "\n"
        message += "Function: " + inputClass.getFunctionName() + "\n"
        self.GameMsg(message)